Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.logging.log4j.core.appender
Class SmtpAppender

    java.lang.Object
      org.apache.logging.log4j.core.AbstractLifeCycle
          org.apache.logging.log4j.core.filter.AbstractFilterable
              org.apache.logging.log4j.core.appender.AbstractAppender
                  org.apache.logging.log4j.core.appender.SmtpAppender

All Implemented Interfaces:
  Serializable, Appender, Filterable, LifeCycle

    @Plugin(name="SMTP",
            category="Core",
            elementType="appender",
            printObject=true)
    public final class SmtpAppender

extends AbstractAppender

Send an e-mail when a specific logging event occurs, typically on errors or fatal errors.

The number of logging events delivered in this e-mail depend on the value of BufferSize option. The `SmtpAppender` keeps only the last `BufferSize` logging events in its cyclic buffer. This keeps memory requirements at a reasonable level while still delivering useful application context. By default, an email message will formatted as HTML. This can be modified by setting a layout for the appender. By default, an email message will be sent when an ERROR or higher severity message is appended. This can be modified by setting a filter for the appender.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface org.apache.logging.log4j.core.LifeCycle
`LifeCycle.State`

Field Summary

Fields inherited from class org.apache.logging.log4j.core.AbstractLifeCycle
`LOGGER`

Method Summary
`void` | `append(LogEvent event)` Perform SmtpAppender specific appending actions, mainly adding the event to a cyclic buffer and checking if the event triggers an e-mail to be sent.
`static SmtpAppender` | `createAppender(String name, String to, String cc, String bcc, String from, String replyTo, String subject, String smtpProtocol, String smtpHost, String smtpPortStr, String smtpUsername, String smtpPassword, String smtpDebug, String bufferSizeStr, Layout<? extends Serializable> layout, Filter filter, String ignore)` Create a SmtpAppender.
`boolean` | `isFiltered(LogEvent event)` Capture all events in CyclicBuffer.

Methods inherited from class org.apache.logging.log4j.core.appender.AbstractAppender
`error, error, error, getHandler, getLayout, getName, ignoreExceptions, parseInt, setHandler, toString`

Methods inherited from class org.apache.logging.log4j.core.filter.AbstractFilterable
`addFilter, getFilter, hasFilter, removeFilter, start, stop`

Methods inherited from class org.apache.logging.log4j.core.AbstractLifeCycle
`equalsImpl, getState, hashCodeImpl, isInitialized, isStarted, isStarting, isStopped, isStopping, setStarted, setStarting, setState, setStopped, setStopping`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.logging.log4j.core.LifeCycle
`getState, isStarted, isStopped, start, stop`

Method Detail

### createAppender

    @PluginFactory
    public static SmtpAppender createAppender(@PluginAttribute(value="name")
                                                            String name,
                                                            @PluginAttribute(value="to")
                                                            String to,
                                                            @PluginAttribute(value="cc")
                                                            String cc,
                                                            @PluginAttribute(value="bcc")
                                                            String bcc,
                                                            @PluginAttribute(value="from")
                                                            String from,
                                                            @PluginAttribute(value="replyTo")
                                                            String replyTo,
                                                            @PluginAttribute(value="subject")
                                                            String subject,
                                                            @PluginAttribute(value="smtpProtocol")
                                                            String smtpProtocol,
                                                            @PluginAttribute(value="smtpHost")
                                                            String smtpHost,
                                                            @PluginAttribute(value="smtpPort")
                                                            String smtpPortStr,
                                                            @PluginAttribute(value="smtpUsername")
                                                            String smtpUsername,
                                                            @PluginAttribute(value="smtpPassword")
                                                            String smtpPassword,
                                                            @PluginAttribute(value="smtpDebug")
                                                            String smtpDebug,
                                                            @PluginAttribute(value="bufferSize")
                                                            String bufferSizeStr,
                                                            @PluginElement(value="Layout")
                                                            Layout<? extends Serializable> layout,
                                                            @PluginElement(value="Filter")
                                                            Filter filter,
                                                            @PluginAttribute(value="ignoreExceptions")
                                                            String ignore)

  Create a SmtpAppender.

  Parameters:
    `name` - The name of the Appender.
    `to` - The comma-separated list of recipient email addresses.
    `cc` - The comma-separated list of CC email addresses.
    `bcc` - The comma-separated list of BCC email addresses.
    `from` - The email address of the sender.
    `replyTo` - The comma-separated list of reply-to email addresses.
    `subject` - The subject of the email message.
    `smtpProtocol` - The SMTP transport protocol (such as "smtps", defaults to "smtp").
    `smtpHost` - The SMTP hostname to send to.
    `smtpPortStr` - The SMTP port to send to.
    `smtpUsername` - The username required to authenticate against the SMTP server.
    `smtpPassword` - The password required to authenticate against the SMTP server.
    `smtpDebug` - Enable mail session debuging on STDOUT.
    `bufferSizeStr` - How many log events should be buffered for inclusion in the message?
    `layout` - The layout to use (defaults to HtmlLayout).
    `filter` - The Filter or null (defaults to ThresholdFilter, level of ERROR).
    `ignore` - If `"true"` (default) exceptions encountered when appending events are logged; otherwise they are propagated to the caller.
  Returns:
    The SmtpAppender.

### isFiltered

    public boolean isFiltered(LogEvent event)

  Capture all events in CyclicBuffer.

  Specified by:
    `isFiltered` in interface `Filterable`
  Overrides:
    `isFiltered` in class `AbstractFilterable`
  Parameters:
    `event` - The Log event.
  Returns:
    true if the event should be filtered.

### append

    public void append(LogEvent event)

  Perform SmtpAppender specific appending actions, mainly adding the event to a cyclic buffer and checking if the event triggers an e-mail to be sent.

  Parameters:
    `event` - The Log event.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2015 Apache Software Foundation. All Rights Reserved.
Apache Logging, Apache Log4j, Log4j, Apache, the Apache feather logo, the Apache Logging project logo, and the Apache Log4j logo are trademarks of The Apache Software Foundation.